package com.its.api.its.service.unit;

import com.its.api.its.model.dto.unit.TbUnitSystDto;
import com.its.api.its.model.dto.unit.TbUnitSystSttsDto;
import com.its.api.its.model.entity.unit.TbUnitSyst;
import com.its.api.its.repository.unit.TbUnitSystRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbUnitSystService {

    private final TbUnitSystRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbUnitSyst requireOne(String id) {
        return repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbUnitSystDto> findAll() {
        List<TbUnitSystDto> result = new ArrayList<>();
        List<TbUnitSyst> data = this.repo.findAll();
        for (TbUnitSyst entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbUnitSystDto findById(String id) {
        TbUnitSyst entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbUnitSystDto updateById(String id, TbUnitSystDto.TbUnitSystUpdReq req) {
        TbUnitSyst entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbUnitSystDto> mergeInfoList(List<TbUnitSystDto.TbUnitSystUpdReq> reqList) {
        List<TbUnitSystDto> result = new ArrayList<>();
        for (TbUnitSystDto.TbUnitSystUpdReq req : reqList) {
            TbUnitSyst obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbUnitSystDto mergeInfo(TbUnitSystDto.TbUnitSystUpdReq req) {
        TbUnitSyst obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbUnitSystDto deleteById(String id) {
        TbUnitSyst entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbUnitSystDto> deleteByIds(List<String> ids) {
        List<TbUnitSystDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbUnitSyst> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    /**
     * 프로세스 목록 조회(이력조회-프로세스상태이력)
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbUnitSystDto> findAllList() {
        List<TbUnitSystDto> result = new ArrayList<>();
        List<TbUnitSyst> data = this.repo.findAllList();
        if (data != null) {
            data.forEach(obj -> {
                result.add(obj.toDto());
            });
        }
        return result;
    }

    /**
     * 프로세스 상태 정보 전체 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbUnitSystSttsDto> findAllStts() {

        List<TbUnitSystSttsDto> result = new ArrayList<>();
        List<TbUnitSyst> unit = this.repo.findAllList();
        unit.forEach(obj -> {
            result.add(obj.toSttsDto());
        });

        return result;
/*
        if (unit != null) {
            unit.forEach(obj -> {
                unitMap.put(obj.getSystId(),
                        TbUnitSystSttsDto.builder()
                                .systId(obj.getSystId())
                                .systNm(obj.getSystNm())
                                .systSttsCd("1")
                                .systSttsDesc("이상")
                                .updtDt("19700101000000")
                                .build());
            });
        }

        List<TbUnitSystStts> data = this.repo.findAll();
        if (data == null) {
            return new ArrayList<>(unitMap.values());
        }

        data.forEach(obj -> {
            TbUnitSystSttsDto sttsDto = unitMap.get(obj.getSystId());
            if (sttsDto != null) {
                sttsDto.setUpdtDt(obj.getUpdtDt());
                if (("SPS1").equals(obj.getSystSttsCd())) {
                    String missYn = ItsUtils.getMissSttsYn(sttsDto.getUpdtDt());
                    if (!("Y").equals(missYn)) {
                        sttsDto.setSystSttsCd("0");
                        sttsDto.setSystSttsDesc("정상");
                    }
                }
            }
        });
        return new ArrayList<>(unitMap.values());*/
    }

}
